=== debian/changelog ===
kodi (2:19.0+dfsg1-1) unstable; urgency=medium

  * New upstream version 19.0+dfsg1
  * Declare proper Debian release splitting kodi-addons-dev (Closes: #980846)
  * Detect and honor big-endian architectures
  * Refresh cdatetime-std-chrono patch

 -- Vasyl Gello <vasek.gello@gmail.com>  Fri, 19 Feb 2021 00:02:45 +0000

kodi (2:19.0~rc1+git20210119.8c761c4+dfsg1-2) experimental; urgency=medium

  * Team upload.
  * Re-instate the kodi-addons-dev-common package split.

 -- Mattia Rizzolo <mattia@debian.org>  Wed, 20 Jan 2021 01:56:06 +0100
