=== debian/watch ===
version=4

# Alpha bare git branch
#
# Since v20, bare git snapshots must follow the tagged release cycle:
#
#      pretty=20.0~alphaX+git%cd.%h, \
#      pretty=20.0~betaX+git%cd.%h, \
#      pretty=20.0~rcX+git%cd.%h, \
#
# where X starts with zero. The 'pretty' attribute must be changed manually
# after the correspondent tagged release is published.
#
#opts="mode=git, \
#      pgpmode=none, \
#      pretty=20.0~alpha0+git%cd.%h, \
#      repack, \
#      repacksuffix=+dfsg1, \
#      compression=xz, \
#      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
#      dversionmangle=auto" \
#https://github.com/xbmc/xbmc \
#HEAD debian

# Tagged releases
#
opts="repack, \
      compression=xz, \
      repacksuffix=+dfsg1,\
      uversionmangle=s/\([\.0-9a-zA-Z]\)-.*$/\1/;s/rc/~rc/;s/a/~alpha/;s/b/~beta/;s/RC/~rc/;s/A/~alpha/;s/B/~beta/, \
      dversionmangle=auto" \
https://github.com/xbmc/xbmc/tags .*archive/?(\d\S*)-[A-Z].*\.tar\.gz

# date

opts="component=libdate-tz-embedded, \
      repack, \
      compression=xz, \
      dversionmangle=auto" \
https://github.com/HowardHinnant/date/tags .*archive/v?(\d\S*)\.tar\.gz \
ignore

# libdvdread

opts="component=libdvdread-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdread/([\d][\d\.]+[a-z]?)/libdvdread-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore

# libdvdnav

opts="component=libdvdnav-embedded, \
      repack, \
      compression=xz, \
      pgpsigurlmangle=s/$/.asc/" \
https://download.videolan.org/pub/videolan/libdvdnav/([\d][\d\.]+[a-z]?)/libdvdnav-([\d][\d\.]+[a-z]?)\.tar\.(?:gz|bz2|xz) \
ignore
