=== debian/changelog ===
kodi (2:19.1+dfsg2-1) unstable; urgency=medium

  * New upstream version 19.1+dfsg2
  * Merge 'bullseye' branch into master and revert patches
    related to newer libdvdread and branch isolation.
  * Drop the patch downgrading ffmpeg to fit buster-backports.

 -- Vasyl Gello <vasek.gello@gmail.com>  Mon, 07 Jun 2021 16:42:08 +0200

kodi (2:19.0+dfsg1-2) unstable; urgency=medium

  * Add missing font dependency (Closes: #985497)
  * Fix github ref
  * Branch out bullseye
  * Refresh cdatetime-std-chrono patch (Closes: #984682)
  * libdate-tz: Fix crash for early local times and USE_OS_TZDB

 -- Vasyl Gello <vasek.gello@gmail.com>  Sun, 30 May 2021 04:57:39 +0000

kodi (2:19.1+dfsg1-1~exp0) experimental; urgency=medium

  * New upstream version 19.1+dfsg1
  * Add missing font dependency (Closes: #985497)
  * Fix links to Github releases in watchfile
  * Refresh patches
  * Prepare for official backport
  * Refresh cdatetime-std-chrono patch (Closes: #984682)
  * libdate-tz: Fix crash for early local times and USE_OS_TZDB

 -- Vasyl Gello <vasek.gello@gmail.com>  Sat, 15 May 2021 21:15:26 +0000
